program f

 implicit none 

 integer,parameter::input_unit=10,lng_unit=11,lat_unit=12,time_unit=13,&
                    output_unit=20,config_unit=30

 integer::imax,jmax

 integer::i,j,n

 integer::grdi,grdj
 integer::stat
 integer::izzz

 integer::jyr,jmon,jday,jhour,jmin,jsec
 integer::uyr,umon,uday,uhour,umin,usec
 integer::gyr,gmon,gday,ghour,gmin,gsec

 integer::ijday,imjday

 real::lng,lat
 real::d,tm
 real::grdlng,grdlat

 double precision::dmjday

 character(14)::cdate,gdate

 character(200)::config_file
 character(200)::lat_file,lng_file,latlng_dir,time_file
 character(200)::dir_input_f,input_f
 character(200)::dir_output_f,output_f
 character(200)::varible_name,time_name

 character(200)::czzz

 config_file="config/format.txt"
 output_f="1p_pickup_exam.dat"

!***** read format.txt *****
 open(config_unit,FILE=config_file,STATUS='old')

 read(config_unit,*)imax,izzz
 read(config_unit,*)jmax,izzz
 read(config_unit,*)varible_name,izzz

 read(config_unit,'(a)')czzz
 dir_input_f=czzz(1:index(czzz,"/"))

 do i=1,5,1
   read(config_unit,'()')
 enddo

 read(config_unit,'(a)')czzz
 dir_output_f=czzz(1:index(czzz,"/"))

 read(config_unit,'()')

 read(config_unit,'(a)')czzz
 latlng_dir=czzz(1:index(czzz,"/"))

 read(config_unit,*)lat_file,izzz
 read(config_unit,*)lng_file,izzz

 read(config_unit,*)time_name,izzz

 close(config_unit)

! input
 write(*,*)"YYYY?"
 read(*,*)jyr

 write(*,*)"MM?"
 read(*,*)jmon

 write(*,*)"DD?"
 read(*,*)jday

 write(*,*)"HH?"
 read(*,*)jhour

 write(*,*)"MM?"
 read(*,*)jmin

 write(*,*)"領域を指定"

 write(*,*)"lng?"
 read(*,*)lng

 write(*,*)"lat?"
 read(*,*)lat

 open(lng_unit,FILE=latlng_dir(1:len_trim(latlng_dir))//lng_file,&
   FORM='unformatted',STATUS='old',ACCESS ='direct',&
   CONVERT='big_endian',RECL=4*imax*jmax)

 open(lat_unit,FILE=latlng_dir(1:len_trim(latlng_dir))//lat_file,&
   FORM='unformatted',STATUS='old',ACCESS ='direct',&
   CONVERT='big_endian',RECL=4*imax*jmax)

 call searchgrid_dis(imax,jmax,lat_unit,lng_unit,lat,lng,grdi,grdj,grdlng,grdlat)

 close(lng_unit)
 close(lat_unit)

 jsec=0

 call jst2utc(jyr,jmon,jday,jhour,jmin,jsec,uyr,umon,uday,uhour,umin,usec)

 call int2chara(uyr,umon,uday,uhour,umin,usec,cdate)

 input_f=dir_input_f(1:len_trim(dir_input_f))//cdate(1:(len_trim(cdate)-2))//&
    varible_name(1:len_trim(varible_name))//".bin"

 time_file=cdate(1:(len_trim(cdate)-2))//time_name(1:len_trim(time_name))//".bin"

 open(input_unit,FILE=input_f,&
   FORM='unformatted',STATUS='old',ACCESS ='direct',CONVERT='big_endian',&
   RECL=4)

 read(input_unit,rec=imax*(grdj-1)+grdi)d

 call greg2jul(uyr,umon,uday,ijday,imjday)

 open(time_unit,FILE=dir_input_f(1:len_trim(dir_input_f))//time_file,&
   FORM='unformatted',STATUS='old',ACCESS ='direct',&
   CONVERT='big_endian',RECL=4)

 read(time_unit,rec=imax*(grdj-1)+grdi)tm
 write(*,*)tm
 dmjday=dble(imjday)+dble(tm)

 call mjul2greg(dmjday,gyr,gmon,gday,ghour,gmin,gsec)

 call int2chara(gyr,gmon,gday,ghour,gmin,gsec,gdate)

 open(output_unit,FILE=dir_output_f(1:len_trim(dir_output_f))//"/"//output_f,STATUS='unknown')

 write(output_unit,*)"input-lng input-lat standard-lng standard-lat value time(YYYYMMDDHHmmss(UTC))"

 write(output_unit,'(f8.3,f8.3,f8.3,f8.3,f10.4, " ",a14)')lng,lat,grdlng,grdlat,d,gdate

 close(input_unit)
 close(time_unit)
 close(output_unit)

end program f


Subroutine greg2jul(yr,mon,dy,jday,mjday)

 implicit none

 integer,intent(in)::yr,mon,dy

 integer,intent(out)::jday,mjday

 integer::a,b
 integer::y,m,d
 real::rjday,rmjday

 if(mon .le. 2)then
   y=yr-1
   m=mon+12
   d=dy
 else
   y=yr
   m=mon
   d=dy
 endif

 a=int(y/100)
 b=int(2-a+int(a/4))

 rjday=int(365.25*y)+int(30.6001*(m+1))+d+1720994.5+b
 jday=ifix(rjday)

 mjday=int(nint(int(365.25*(y+4716))+int(30.6001*(m+1))+d+b-1524.5)-2400000.5)

end Subroutine greg2jul



Subroutine mjul2greg(mjday,yr,mon,dy,hr,mn,sc)

 implicit none

 double precision,intent(in)::mjday

 integer,intent(out)::yr,mon,dy,hr,mn,sc

 double precision::jday
 integer::aa,bb,cc,ee,ff,gg,hh
 double precision::ii

 jday=mjday+2400000.5

 aa=int(jday+68569.5)
 bb=int(aa/36524.25)
 cc=aa-int(36524.25*bb+0.75)
 ee=int((cc+1)/365.25025) 
 ff=cc-int(365.25*ee)+31
 gg=int(ff/30.95)
 hh=int(gg/11)
 ii=jday+0.5-int(jday+0.5)

 yr=100*(bb-49)+ee+hh
 mon=gg-12*hh+2
 dy=ff-int(30.59*gg)
 hr=int(24*ii)
 mn=int(1440*(ii-hr/24.0))
 sc=int(86400*(ii-hr/24.0-mn/1440.0))

! write(*,*)yr,mon,dy,hr,mn,sc

end Subroutine mjul2greg


Subroutine searchgrid_dis(imax,jmax,lat_unit,lng_unit,lat,lng,grdi,grdj,grdlng,grdlat)

 implicit none

 integer,intent(in)::imax,jmax
 integer,intent(in)::lat_unit,lng_unit
 real,intent(in)::lat,lng

 integer,intent(out)::grdi,grdj
 real,intent(out)::grdlng,grdlat

 real,parameter::radius=6.37,pai=3.14159265

 integer::i,j

 double precision::angle,min_angle
 double precision::amp_v1,amp_v2,innerpro
 double precision,dimension(3)::v1,v2
 real,dimension(imax,jmax)::a,b

 grdi=1
 grdj=1

 v1(1)=cos(pai*dble(lat)/180.0)*cos(2.0*pai*dble(lng)/360.0)
 v1(2)=cos(pai*dble(lat)/180.0)*sin(2.0*pai*dble(lng)/360.0)
 v1(3)=sin(pai*dble(lat)/180.0)

 amp_v1=sqrt(v1(1)**2+v1(2)**2+v1(3)**2)

 read(lng_unit,rec=1)a
 read(lat_unit,rec=1)b

 min_angle=pai

 do j=1,jmax,1
   do i=1,imax,1

   if(lat .eq. b(i,j))then
     if(lng .eq. a(i,j))then

       grdi=i
       grdj=j

       goto 900

     endif
   endif

   v2(1)=cos(pai*dble(b(i,j))/180.0)*cos(2.0*pai*dble(a(i,j))/360.0)
   v2(2)=cos(pai*dble(b(i,j))/180.0)*sin(2.0*pai*dble(a(i,j))/360.0)
   v2(3)=sin(pai*dble(b(i,j))/180.0)

   amp_v2=sqrt(v2(1)**2+v2(2)**2+v2(3)**2)
   innerpro=v1(1)*v2(1)+v1(2)*v2(2)+v1(3)*v2(3)
   angle=acos(innerpro/(amp_v1*amp_v2))

     if(abs(angle) .le. abs(min_angle))then

       min_angle=angle
       grdi=i
       grdj=j

     endif

   enddo
 enddo
 write(*,*)min_angle

900 continue

 grdlng=a(grdi,grdj)
 grdlat=b(grdi,grdj)

End Subroutine searchgrid_dis


subroutine jst2utc(jyr,jmon,jday,jhour,jsec,jmin,uyr,umon,uday,uhour,usec,umin)

 implicit none

 integer,parameter::tzone=-9

 integer::jyr,jmon,jday,jhour,jsec,jmin
 integer::uyr,umon,uday,uhour,usec,umin

 integer::leap_chk

 integer,dimension(12)::num_date

 data num_date/31,28,31,30,31,30,31,31,30,31,30,31/

 usec=jsec
 umin=jmin

 call check_leapyear(jyr,leap_chk)

 if(jhour .ge. 9)then

   uhour=jhour+tzone
   uday=jday
   umon=jmon
   uyr=jyr

 else

   uhour=jhour+24+tzone

   if(jday .ne. 1)then

     uday=jday-1
     umon=jmon
     uyr=jyr
 
   else

     if(jmon .ne. 1 .and. jmon .ne. 3)then

       umon=jmon-1
       uday=num_date(umon)
       uyr=jyr

     elseif(jmon .eq. 1)then

       umon=jmon-1+12
       uday=num_date(umon)
       uyr=jyr

     elseif(jmon .eq. 3)then

       if(leap_chk .ne. 1)then 

         umon=jmon-1
         uday=num_date(umon)
         uyr=jyr

       else

         umon=jmon-1
         uday=num_date(umon)+1
         uyr=jyr

       endif
     endif
   endif
 endif

end subroutine jst2utc


subroutine check_leapyear(yr,leap_chk)

 implicit none

 integer,intent(in)::yr
 integer,intent(out)::leap_chk

 if(mod(yr,400) .eq. 0) then
   leap_chk=1
 else if((mod(yr,4) .eq. 0).and.(mod(yr,100) .gt. 0)) then
   leap_chk=1
 else
   leap_chk=0
 endif

end subroutine check_leapyear 



subroutine int2chara(uyr,umon,uday,uhour,umin,usec,cdate)

 implicit none

 integer,intent(in)::uyr,umon,uday,uhour,usec,umin

 character(14),intent(out)::cdate

 character(2)::cmon,cday,chour,csec,cmin
 character(4)::cyr

 write(cyr,'(i4)')uyr

 if (umon .ge. 10)then
   write(cmon,'(i2)')umon
 else
   cmon(1:1)="0"
   write(cmon(2:2),'(i1)')umon
 endif

 if (uday .ge. 10)then
   write(cday,'(i2)')uday
 else
   cday(1:1)="0"
   write(cday(2:2),'(i1)')uday
 endif

 if (uhour .ge. 10)then
   write(chour,'(i2)')uhour
 else
   chour(1:1)="0"
   write(chour(2:2),'(i1)')uhour
 endif

 if (umin .ge. 10)then
   write(cmin,'(i2)')umin
 else
   cmin(1:1)="0"
   write(cmin(2:2),'(i1)')umin
 endif

 if (usec .ge. 10)then
   write(csec,'(i2)')usec
 else
   csec(1:1)="0"
   write(csec(2:2),'(i1)')usec
 endif

 cdate=cyr(1:len_trim(cyr))//cmon(1:len_trim(cmon))//cday(1:len_trim(cday))//&
           chour(1:len_trim(chour))//cmin(1:len_trim(cmin))//csec(1:len_trim(csec))

end subroutine int2chara


